#pragma config(Motor,  port1,           frontLeft,     tmotorVex393HighSpeed_HBridge, openLoop, reversed)
#pragma config(Motor,  port2,           backLeft,      tmotorVex393HighSpeed_MC29, openLoop)
#pragma config(Motor,  port3,           claw,          tmotorVex393HighSpeed_MC29, openLoop)
#pragma config(Motor,  port4,           slider,        tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port5,           bigLift,       tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port6,           chainBarL,     tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port7,           chainBarR,     tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port8,           pusher,        tmotorVex393_MC29, openLoop)
#pragma config(Motor,  port9,           frontRight,    tmotorVex393HighSpeed_MC29, openLoop)
#pragma config(Motor,  port10,          backRight,     tmotorVex393HighSpeed_HBridge, openLoop)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

// This file is part of Vex-920-2017, and is therefore licensed under the GNU GPLv3 public license.

/* Controls
	LJoystick + RJoystick: Tank movement
	Btn6U/D: Raise/lower slider
	Btn8L/R: Drop/pick up with claw
	Btn8U/D: Raise/lower big lift
	Btn5U/D: Raise/lower chain bar
	Btn7U/D: Push/retract mobile goal pusher
*/

// This code is for the VEX cortex platform
#pragma platform(VEX2)

// Select Download method as "competition"
#pragma competitionControl(Competition)

//Main competition background code...do not modify!
#include "Vex_Competition_Includes.c"

/*! General Methods: User Control
	Applies a deadband of 25 to the provided float.
	\param channel the input channel to apply the deadband to.
*/
float deadband(float input) {
	return (abs(input) < 25) ? 0 : input;
}

void pre_auton() {
	// Set bStopTasksBetweenModes to false if you want to keep user created tasks
	// running between Autonomous and Driver controlled modes. You will need to
	// manage all user created tasks if set to false.
	bStopTasksBetweenModes = true;

	// Set bDisplayCompetitionStatusOnLcd to false if you don't want the LCD
	// used by the competition include file, for example, you might want
	// to display your team name on the LCD in this function.
	bDisplayCompetitionStatusOnLcd = false;

	// All activities that occur before the competition starts
	// Example: clearing encoders, setting servo positions, ...
}

task autonomous() {
	AutonomousCodePlaceholderForTesting();
}

task usercontrol() {
	while (true) {
		motor[port1] = deadband(vexRT[Ch3]);
		motor[port2] = deadband(vexRT[Ch3]);

		motor[port9] = deadband(vexRT[Ch2]);
		motor[port10] = deadband(vexRT[Ch2]);

		// Autonomous
		if(vexRT[Btn7U] == 1) {
			// Drive Forwards to Mobile Goal
			motor[backRight] = 120;
			motor[backLeft] = 120;
			motor[frontRight] = 120;
			motor[frontLeft] = 120;
			motor[chainBarL] = -120;
			motor[chainBarR] = -120;

			wait1Msec(1950);
			motor[chainBarL] = 0;
			motor[chainBarR] = 0;
			wait1Msec(1600);
			motor[port1] = 0;
			motor[port2] = 0;
			motor[port9] = 0;
			motor[port10] = 0;

			// Sliders up and drop cone
			motor[slider] = 120;
			wait1Msec(750);
			motor[slider] = 0;

			motor[port1] = -120;
			motor[port2] = -120;
			motor[port9] = -120;
			motor[port10] = -120;

			motor[chainBarL] = 120;
			motor[chainBarR] = 120;
			wait1Msec(1500);
			motor[chainBarL] = 0;
			motor[chainBarR] = 0;
			motor[claw] = 120;
			wait1Msec(800);
			motor[chainBarL] = -120;
			motor[chainBarR] = -120;
			motor[claw] = 0;
			wait1Msec(1100);
			motor[chainBarL] = 0;
			motor[chainBarR] = 0;

			// Drive and line up for drop
			motor[backRight] = 120;
			motor[backLeft] = -120;
			motor[frontRight] = 120;
			motor[frontLeft] = -120;
			wait1Msec(1050);
			motor[backRight] = 120;
			motor[backLeft] = 120;
			motor[frontRight] = 120;
			motor[frontLeft] = 120;
			wait1Msec(900);
			motor[backRight] = 120;
			motor[backLeft] = -120;
			motor[frontRight] = 120;
			motor[frontLeft] = -120;
			wait1Msec(1050);
			motor[backRight] = 120;
			motor[backLeft] = 120;
			motor[frontRight] = 120;
			motor[frontLeft] = 120;
			wait1Msec(3000);
			motor[backRight] = 0;
			motor[backLeft] = 0;
			motor[frontRight] = 0;
			motor[frontLeft] = 0;
		}

		// Sliders
		if(vexRT[Btn6U] == 1) {
			motor[slider] = 120;
		} else if(vexRT[Btn6D] == 1) {
			motor[slider] = -120;
		} else {
		motor[slider] = 0;
		}

		// Claw
		if(vexRT[Btn8UXmtr2] == 1) {
			motor[claw] = 120;
		} else if(vexRT[Btn8DXmtr2] == 1) {
			motor[claw] = -120;
		} else {
			motor[claw] = 0;
		}

		// Big Lift
		if(vexRT[Btn5UXmtr2] == 1) {
			motor[bigLift] = 120;
		} else if(vexRT[Btn5DXmtr2] == 1) {
			motor[bigLift] = -120;
		} else {
			motor[bigLift] = 0;
		}

		// Chain Bar(s)
		if(vexRT[Btn6UXmtr2] == 1) {
			motor[chainBarR] = 120;
			motor[chainBarL] = 120;
		} else if(vexRT[Btn6DXmtr2] == 1) {
			motor[chainBarR] = -120;
			motor[chainBarL] = -120;
		} else {
			motor[chainBarL] = 0;
			motor[chainBarR] = 0;
		}

		// Pusher
		if(vexRT[Btn5U] == 1) {
			motor[pusher] = 120;
		} else if(vexRT[Btn5D] == 1) {
			motor[pusher] = -120;
		} else {
			motor[pusher] = 0;
		}
	}
}
